您的位置:首页 > 其它

Backward Digit Sums POJ3187

2016-07-25 10:32 176 查看
Backward Digit Sums

Time Limit: 1000MS Memory Limit: 65536K

Total Submissions: 6223 Accepted: 3602

Description

FJ and his cows enjoy playing a mental game. They write down the numbers from 1 to N (1 <= N <= 10) in a certain order and then sum adjacent numbers to produce a new list with one fewer number. They repeat this until only a single number is left. For example, one instance of the game (when N=4) might go like this:

3   1   2   4

4   3   6

7   9

16


Behind FJ’s back, the cows have started playing a more difficult game, in which they try to determine the starting sequence from only the final total and the number N. Unfortunately, the game is a bit above FJ’s mental arithmetic capabilities.

Write a program to help FJ play the game and keep up with the cows.

Input

Line 1: Two space-separated integers: N and the final sum.

Output

Line 1: An ordering of the integers 1..N that leads to the given sum. If there are multiple solutions, choose the one that is lexicographically least, i.e., that puts smaller numbers first.

Sample Input

4 16

Sample Output

3 1 2 4

Hint

Explanation of the sample:

There are other possible sequences, such as 3 2 1 4, but 3 1 2 4 is the lexicographically smallest.

Source

USACO 2006 February Gold & Silver

题意:给1,2,…,n个数字,这些数字形成一个排列

a[0] a[1] a[2]

a[0]+a[1] a[1]+a[2]

sum=a[0]+a[1]+a[2]

依照如上的规律,运算出最后一个和sum,

现在给定n和sum,求出排列

思路:

暴力枚举出全排列

本来想贪心的,结果wa掉了

注意这几组数据

5 48

1 2 3 4 5

5 45

2 1 3 4 5

6 103

2 3 1 5 4 6

尤其是最后一组,会发现中间的部分无法简单的贪心,直接将数值小的数字放在前面是错误的写法。

#include<cstdio>
#include<cstring>
#include<vector>
#include<algorithm>
using namespace std;
int n,sum;
bool vis[108];
int ans[108];
void help(int a,int b)
{
ans[0]=a;
ans[n-1]=b;
int st=1;

for(int i=1; i<n-1; i++)
{
while(a==st||b==st)
st++;
ans[i]=st++;
//printf("  %d*%d  ",)
}
}
int c(int a,int b)
{
int  res=1;
a=min(a,b-a);
for(int i=0; i<a; i++)
{
res*=(b-a+i+1);
res/=(1+i);
}
return res;
}
int main()
{
while(scanf("%d%d",&n,&sum)!=EOF)
{
int all=0;
all=(n+1)*n/2;
// printf("n:%d\n",n);
memset(vis,0,sizeof vis);

help(1,n);
do
{
int tmp=0;
for(int i=0;i<n;i++)
{
tmp+=c(i,n-1)*ans[i];
}
if(tmp==sum)
break;

}while(next_permutation(ans,ans+n));

for(int i=0; i<n; i++)
{
if(i)
printf(" ");
printf("%d",ans[i]);
}
puts("");
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: